include graphics.e
include get.e
include file.e
include machine.e

without warning
without type_check
with trace

integer screen
screen = graphics_mode(18)

-- Ports
constant Nowhere = 0,
         Lisbon = 1,
         Seville = 2,
         Bordeux = 3,
         Antwerp = 4,
         London = 5,
         Oslo = 6,
         Hamburg = 7,
         Marseille = 8,
         Genoa = 9,
         Pisa = 10,
         Naples = 11,
         Venice = 12,
         Valencia = 13,
         Istanbul = 14

-- Port Data
constant NAME = 1,      
         COMMODITIES = 2,
         PRICES = 3,
         BUY = 1,
         SELL = 2,
         ADJUSTMENTS = 4

-- Commodities
constant Sugar = 1,
         Wool = 2,
         Firearms = 3,
         Artwork = 4,
         Wine = 5,
         Wood = 6,
         Cheese = 7,
         Grapes = 8,
         Porcelin = 9,
         Cloth = 10,
         Cotton = 11,
         Carpet = 12,
         Wheat = 13,
         Marble = 14        

-- Ship and Player data
-- NAME = 1 shared with port data above
-- NOTE: Player commodities = 6
constant HP = 2,
         CARGO = 3,
         CREW = 4,
         GOLD = 5

-- Date components
constant MONTH = 1,
         DAY = 2,
         YEAR = 3

-- Key codes
constant ESC = 27,
         LEFT = 331,
         RIGHT = 333
                
-- Distances between ports		
sequence distances
distances = {
            {0,1,3,4,4,6,5,3,4,4,4,7,2,7},      -- Lisbon
            {1,0,4,5,5,7,6,2,3,3,3,6,1,6},      -- Seville
            {3,4,0,1,1,3,2,6,7,7,7,10,5,10},    -- Bordeux
            {4,5,1,0,1,1,1,7,8,8,8,11,6,11},    -- Antwerp
            {4,5,1,1,0,1,1,7,8,8,8,11,6,11},    -- London
            {6,7,3,1,1,0,1,9,10,10,10,13,8,13}, -- Oslo
            {5,6,2,1,1,1,0,8,9,9,9,12,7,13},    -- Hamburg
            {3,2,6,7,7,9,8,0,1,1,1,4,1,4},      -- Marseille
            {4,3,7,8,8,10,9,1,0,1,1,3,2,3},     -- Genoa
            {4,3,7,8,8,10,9,1,1,0,1,3,2,3},     -- Pisa
            {4,3,7,8,8,10,9,1,1,1,0,3,2,3},     -- Naples
            {7,6,10,11,11,13,12,4,3,3,3,0,5,1}, -- Venice
            {2,1,5,6,6,8,7,1,2,2,2,5,0,5},      -- Valencia
            {7,6,10,11,11,13,12,4,3,3,3,1,5,0}  -- Istanbul 
            }

-- Port data
sequence ports          
ports = {
        {"Lisbon", {Sugar, Cloth, Grapes, Firearms}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Seville", {Sugar, Firearms, Grapes}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Bordeux", {Wine, Cheese, Grapes, Wheat}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Antwerp", {Cheese, Cloth, Wheat}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"London", {Wool, Porcelin, Cheese, Firearms}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Oslo", {Wood, Cheese}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Hamburg", {Cheese, Cloth}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Marseille", {Wine, Grapes, Cloth}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Genoa", {Wheat, Wine}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Pisa", {Marble, Artwork}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Naples", {Marble, Artwork, Porcelin}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Venice", {Wine, Cloth, Porcelin}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Valencia", {Wheat, Grapes, Wool}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}},
        {"Istanbul", {Carpet, Artwork, Cotton, Firearms}, {{},{},{},{},{},{},{},{},{},{},{},{},{},{}}, {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}}
        }

sequence months, length_months, Date
months = {"January","February","March","April","May","June","July","August","September","October","November","December"}
length_months = {31,29,31,30,31,30,31,31,30,31,30,31}
Date = {1,1,1500} -- month, day, year

sequence commodities
commodities = {"Sugar","Wool","Firearms","Artwork","Wine","Wood","Cheese","Grapes","Porcelin","Cloth","Cotton","Carpet","Wheat","Marble"}

sequence player
player = {"Falcon", {15,15}, {0,200}, {10,10}, 200, repeat(0, length(commodities))}

object junk
junk = {}

atom location, destination, input, key, days_left
location = Lisbon
destination = Nowhere
input = 0
key = -1
days_left = 365

-- Accurate timing
atom t
t = 0
tick_rate(100)

-- Variables for black jack in the Tavern
sequence cards, types, player_hand, dealer_hand
-- Card suits {type, suit, value}
cards = {}
-- 10 = Jack, 11 = Queen, 12 = King, 13 = Ace
types = {"J", "Q", "K", "A"}
player_hand = {}
dealer_hand = {}
integer current_card
current_card = 1

-- Create card deck
-- Suites
for h = 3 to 6 do
    -- Cards
    for i =  2 to 14 do
        -- Face cards
        if i >= 11 and i <= 13 then
            cards = append(cards, {types[i-10], h, 10})
        -- Aces
        elsif i = 14 then
            cards = append(cards, {types[4], h, 11})
        -- Other cards
        else
            cards = append(cards, {i, h, i})
        end if
    end for
end for


-- Set market prices
for i = 1 to length(ports) do
    -- Preset prices for commodities sold at current port
    for j = 1 to length(ports[i][COMMODITIES]) do
        ports[i][PRICES][ports[i][COMMODITIES][j]] &= {0, rand(20)}
    end for
    -- Randomly set prices for the other commodities
    for k = 1 to 14 do
        if length(ports[i][PRICES][k]) = 0 then
            ports[i][PRICES][k] &= {rand(20), 0}
        end if
    end for
end for 

procedure finish()
    clear_screen()
    printf(1, "On %s %d, %d, the last coins of your hard won payment were collected!\n\n", {months[Date[1]], Date[2], Date[3]})
    puts(1, "Press any key")
    key = wait_key()
    clear_screen()
    puts(1, "TRIUMPH!\n\n")
    puts(1, "The gold coins rain down upon Cornelius Skullman's desk in a twinkling shower!\n")
    puts(1, "'My family's debt is paid in full and on time.' you say with a grin. 'I look\nforward to our renewed competition!'\n")
    puts(1, "Skullman's face turns a dark red and he sputters helplessly as you walk from theroom.\n\n")
    printf(1, "Long live the stout %s and her stalwart captain! May both prosper for many\nyears to come!", {player[NAME]})
    puts(1, "\n\nTHE END")
    
    puts(1, "\n\nPress any key")

    key = wait_key()
    
    abort(0)
end procedure

function calc_cargo()
    atom a
    a = 0
    for i = 1 to length(commodities) do
        a += player[6][i]
    end for
    return a
end function

procedure print_header()
    
    -- Check to see if enough gold has been accumulated to pay debts
    if player[GOLD] >= 100000 then
        finish()
    end if
    
    clear_screen()

    -- Date 
    printf(1, "[-%s %d, %d-]\tDays Remaining: %d\n", {months[Date[MONTH]],Date[DAY],Date[YEAR], days_left})

    -- Player info
    puts(1, repeat(220,76) & "\n") -- Border
    printf(1, "SHIP     \tHP\\MAX   \tCARGO\\MAX\tCREW\\MAX\tGOLD\\DEBT\n", {})
    printf(1, "----     \t------   \t---------\t--------\t---------\n", {})
    printf(1, "%s    \t%d\\%d    \t%d\\%d    \t%d\\%d    \t%d\\100000 \n", {player[NAME],player[HP][1],player[HP][2],calc_cargo(),player[CARGO][2],player[CREW][1],player[CREW][2],player[GOLD]})
    puts(1, repeat(223,76) & "\n") -- Border
    position(8,1)
end procedure

function in_port()
    printf(1, "The lovely port city of %s.\n\n", {ports[location][NAME]})
    puts(1, "(1) Buy and Sell goods at the market\n")
    puts(1, "(2) Wet your whistle at the tavern\n")
    puts(1, "(3) Pay a visit to the ship yards\n")
    puts(1, "(4) Book a room at the inn\n")
    puts(1, "(5) Set sail!\n\n")

    input = prompt_number("> ", {1,5})

    return input
    
end function

procedure in_market()
    printf(1, "The port of %s deals in the following goods:\n\n", {ports[location][NAME]})
    puts(1, "COMMODITIES\tWILL BUY FOR\tWILL SELL FOR\tYOU HAVE\n")
    puts(1, "-----------\t------------\t-------------\t--------\n")
        for i = 1 to length(commodities) do
            printf(1, "(%d) %s\t\t%-1.d\t\t%-1.d\t%d\n", {i, commodities[i],ports[location][PRICES][i][BUY], ports[location][PRICES][i][SELL], player[6][i]})
        end for
    printf(1, "(%d) Leave Market", {length(commodities)+1}) 
    puts(1, "\n\n")
end procedure

function in_tavern()
    printf(1, "Welcome to the finest tavern in %s! What can I do for ye?\n\n", {ports[location][NAME]})
    puts(1, "(1) Have a drink and hear the gossip (1 gold)\n")
    puts(1, "(2) Play a game of dice\n")
    puts(1, "(3) Play a game of cards\n")
    puts(1, "(4) Round up a crew\n")
    puts(1, "(5) Leave the tavern\n\n")

    input = prompt_number("> ", {1,5})

    return input

end function

function in_shipyard()
    printf(1, "The ship yards of %s are booming with activity.\n\n", {ports[location][NAME]})
    puts(1, "(1) Rename your ship\n")
    puts(1, "(2) Make repairs\n")
    puts(1, "(3) Overhaul crew quarters\n")
    puts(1, "(4) Enlarge cargo hold\n")
    puts(1, "(5) Leave the ship yards\n\n")

    input = prompt_number("> ", {1,5})

    return input
    
end function

function in_inn()
    printf(1, "A pleasant inn near the %s waterfront.\n\n", {ports[location][NAME]})
    puts(1, "(1) Save Game\n")
    puts(1, "(2) Exit Game\n")
    puts(1, "(3) Leave the inn\n\n")

    input = prompt_number("> ", {1,3})
    
    return input
    
end function

-- Advance the date by x days
procedure change_date(integer days)
    for i = 1 to days do
        days_left -= 1
        Date[2] += 1
        if Date[2] = length_months[Date[1]] then
            Date[2] = 1
            if Date[1] != 12 then
                Date[1] += 1
            else
                Date[1] = 1
                Date[3] += 1
            end if
        end if
    end for

    -- You've run out of time!
    if days_left = 0 then
        clear_screen()
        puts(1, "\n'Get out of here ye filthy beggar!' the innkeeper shouted, aiming a kick at the ragged man's backside.\n\n")
        puts(1, "'Who was that?' his plump wife asked, looking up from the dough she kneaded.\n")
        puts(1, "He spat into the street then slammed the inn door. 'Naught but a dirty beggar\nlooking for charity', he grumbled.\n")
        puts(1, "'Did you see that coat he wore?' his wife said as she worked. 'Twas a fine\ngentleman's coat under all the dirt and patches.")
        puts(1, "'He could've been someone that\nyou would've tipped yer hat to in the street not a year ago. Cornelius Skullman\n")
        puts(1, "ruined many a proud family in his climb to power...tis a blessed shame.\n\n")
        puts(1, "You were too long in raising the gold to pay your debts! Cornelius Skullman\nseizes all that you have left and throws you into the street...\n\n")
        puts(1, "GAME OVER\n\nPress any key")
        key = wait_key()
        abort(0)
    end if
    
end procedure

function set_sail()

    printf(1, "We are sitting at anchor in %s's harbor.\nSet course, Captain?\n\n", {ports[location][NAME]})    
    for i = 1 to length(ports) do
        printf(1, "(%d) %s\t%d days away\n", {i, ports[i][NAME], distances[location][i]})
    end for
    input = prompt_number("\n> ", {1,length(ports)})
    
    return input
    
end function

procedure intro()
    clear_screen()
    screen = open(current_dir() & "\\story.txt", "r")
        junk = {}
        while not integer(junk) do
            junk = gets(screen)
            puts(1, junk)
        end while
    close(screen)
    puts(1, "\n\nPress any key")
    key = wait_key()
    clear_screen()
    puts(1, "It is now January 1st, 1500.\nYou have 365 days to pay off your debt of 100000 gold pieces!\n\nBest of luck!\n\nPress any key")
    key = wait_key()
    key = -1
end procedure

procedure game_over()
    clear_screen()
    puts(1, "DISASTER!\n\n")
    printf(1, "The %s slips beneath the churning waves carrying your hopes with it.\n", {player[NAME]})
    puts(1, "Even if you were to somehow reach shore alive there is no way that you can earn enough gold to repay your debts ")
    puts(1, "without a ship.\nWater fills your mouth as ")
    puts(1, "you fight against the dead weight of your sodden\nclothing. One way or another, this is the end...\n\n") 
    puts(1, "GAME OVER\n\n")
    puts(1, "Press any key")
    key = wait_key()
    abort(0)
end procedure

function combat()
    sequence attacks    
    integer input, opponent, wounds, opponent_wounds
    attacks = {"Thrust", "Lunge", "Slash"}
    wounds = 0
    opponent_wounds = 0

    while 1 do
        print_header()
        puts(1, "You and your opponent circle each other warily.\n\n")
        
        for i = 1 to length(attacks) do
            printf(1, "(%d) %s\n", {i, attacks[i]})
        end for
    
        input = prompt_number("\nChoose your attack > ", {1, length(attacks)})

        -- Opponent chooses attack
        opponent = rand(4)

        -- Combat results
        -- Identical attacks are parried
        if input = opponent then
            puts(1, "\nSkillfully parried!")
        -- Random outcome
        else
            input = rand(4)
                if input = 1 then
                    puts(1, "\nUgh! You are painfully wounded!")
                    wounds += 1
                elsif input = 2 then
                    puts(1, "\nTouche! The pirate cries out as he is wounded!")
                    opponent_wounds += 1
                elsif input = 3 then
                    puts(1, "\nClang! Sparks fly as your blow is parried!")
                else
                    puts(1, "\nA furious exchange of blows! You have both wounded the other!")
                    wounds += 1
                    opponent_wounds += 1
                end if
                    -- Who won?
                    -- You are defeated
                    if wounds = 3 then
                        return 2
                    -- The pirate is defeated
                    elsif opponent_wounds = 3 then
                        return 1
                    end if  
        end if

        puts(1, "\n\nPress any key")
        key = wait_key()
        key = -1
        
end while

end function

procedure shuffle_deck()
    sequence temp, temp2
    integer t
    temp = cards
    temp2 = {}
    t = 0

    for i = 1 to length(cards) do
        t = rand(length(temp))  
        temp2 = append(temp2, temp[t])
        temp = temp[1..t-1] & temp[t+1..length(temp)]
    end for

    cards = temp2
end procedure

procedure display_cards()
    -- Show dealer's hand
    puts(1, "Dealer's Hand: \t")
    for i = 1 to length(dealer_hand) do
        -- Display face cards and ace
        if sequence(dealer_hand[i][1]) then
            printf(1, "%s%s ", {dealer_hand[i][1], dealer_hand[i][2]})
        -- All other cards
        else
            printf(1, "%d%s ", {dealer_hand[i][1], dealer_hand[i][2]})
        end if
    end for
    
    -- Show your hand
    puts(1, "\n\nYour Hand: \t")
    for i = 1 to length(player_hand) do
        -- Display face cards and ace
        if sequence(player_hand[i][1]) then
            printf(1, "%s%s ", {player_hand[i][1], player_hand[i][2]})
        -- All other cards
        else
            printf(1, "%d%s ", {player_hand[i][1], player_hand[i][2]})
        end if
    end for
end procedure

-- Title Screen
puts(1," _ _ _   __  _ __   __  _    , __  _ __  _______ _ _   __  _ __ \n")
puts(1,"' ) ) ) /  `' )  ) /  )' )  / /  )' )  )   /  ' ) ) ) /  )' )  )\n")
puts(1," / / / /--   /--' /     /--/ /--/  /  / --/    / / / /--/  /  / \n")
puts(1,"/ ' (_(___, /  \\_(__/  /  (_/  (_ /  (_(_/    / ' (_/  (_ /  (_ \n\n")

puts(1, "Written by David Stanger\n")
puts(1, "v0.3 February 2005\n\n")
puts(1, "Press any key")
key = wait_key()
key = -1

-- New or Saved game?
while 1 do
    clear_screen()
    puts(1, "Welcome, Matey, to MERCHANTMAN!\n\n")
    puts(1, "(1) Start a new game\n")
    puts(1, "(2) Load a saved game\n")
    puts(1, "(3) Exit\n\n")
    input = prompt_number("> ", {1,3})
        -- Start a new game
        if input = 1 then
             intro()
            exit
        -- Load a saved game
        elsif input = 2 then
            junk = dir(current_dir() & "\\*.sav")
                -- No saved games 
                if integer(junk) then
                    clear_screen()
                    puts(1, "No saved games found.\n\n")
                    puts(1, "Press any key")
                    key = wait_key()
                    key = -1
                -- Select a saved game
                else
                    -- Choose a file or exit to title again
                    clear_screen()
                    puts(1, "Continue which adventure?\n\n")
                        for i = 1 to length(junk) do
                            printf(1, "(%d) %s\n", {i, junk[i][D_NAME]})
                        end for
                    printf(1, "(%d) Exit", {length(junk)+1})
                    input = prompt_number("\n\n> ", {1, length(junk)+1})
                        if input != length(junk) + 1 then
                            -- Open the file
                            screen = open(current_dir() & "\\" & junk[input][D_NAME], "r")
                            -- Read out data
                            player = get(screen)
                            player = player[2]
                            ports = {}
                                for i = 1 to 14 do
                                    junk = get(screen)
                                    ports = append(ports, junk[2])
                                end for
                            junk = get(screen)
                            location = junk[2]
                            Date = {}
                                for i = 1 to 3 do
                                    junk = get(screen)
                                    Date = append(Date, junk[2])
                                end for
                            junk = get(screen)
                            days_left = junk[2]
                            close(screen)
                            exit
                        end if
                end if
        -- Exit game	
        else
            clear_screen()
            abort(0)
        end if
end while

-- Main program loop
while 1 do
    print_header()
    input = in_port()   
        -- Buy and Sell at the market
        if input = 1 then
            while 1 do
            print_header()                  
            in_market()
            input = prompt_number("What are ye interested in? > ", {1, length(commodities)+1})
                -- If a commoditiy is chosen
                if input != length(commodities)+1 then
                        while 1 do
                            print_header()
                            in_market()
                            printf(1, "(1) Buy %s   (2) Sell %s   (3) Cancel", {commodities[input], commodities[input]})
                            screen = prompt_number("    > ", {1,3})
                                -- Buy goods
                                if screen = 1 then
                                    -- If player has enough gold to spend
                                    if player[GOLD] >= ports[location][PRICES][input][SELL] then    
                                        -- If port deals in this commodity
                                        if ports[location][PRICES][input][SELL] > 0 then    
                                            print_header()
                                            in_market()
                                            printf(1, "How much %s do ye want?", {commodities[input]})
                                            screen = prompt_number(" > ", {0, player[CARGO][2] - player[CARGO][1]})
                                                -- Do you have enough gold?
                                                -- Insufficent funds
                                                if screen * ports[location][PRICES][input][SELL] > player[GOLD] then
                                                    print_header()
                                                    puts(1, "Ye haven't enough gold for that much!\n\n")
                                                    puts(1, "Press any key")
                                                    key = wait_key()
                                                    key = -1
                                                -- Sufficent funds
                                                else
                                                    player[GOLD] -= screen * ports[location][PRICES][input][SELL]
                                                    player[6][input] += screen
                                                    player[CARGO][1] = calc_cargo()
                                                    -- Adjust market price accordingly
                                                    ports[location][ADJUSTMENTS][input][SELL] += screen
                                                    ports[location][PRICES][input][SELL] += floor(ports[location][ADJUSTMENTS][input][SELL] / 100)
                                                    ports[location][ADJUSTMENTS][input][SELL] = 1
                                                end if
                                        end if
                                    end if
                                -- Sell goods
                                elsif screen = 2 then
                                    -- If player has goods to sell
                                    if player[6][input] > 0 then    
                                        -- If port buys this commodity
                                        if ports[location][PRICES][input][BUY] > 0 then
                                            print_header()
                                            in_market()
                                            printf(1, "How much %s will you sell?", {commodities[input]})
                                            screen = prompt_number(" > ", {0, player[6][input]})
                                            player[GOLD] += screen * ports[location][PRICES][input][BUY]
                                            player[6][input] -= screen
                                            player[CARGO][1] = calc_cargo()
                                            -- Adjust market price accordingly
                                            ports[location][ADJUSTMENTS][input][BUY] += screen
                                            ports[location][PRICES][input][BUY] -= floor(ports[location][ADJUSTMENTS][input][BUY] / 100)
                                                -- Prices cannot go below 0
                                                if ports[location][PRICES][input][BUY] < 0 then
                                                    ports[location][PRICES][input][BUY] = 0
                                                end if
                                            ports[location][ADJUSTMENTS][input][BUY] = 0
                                        end if
                                    end if
                                -- Cancel transaction
                                elsif screen = 3 then
                                    exit
                                end if
                        end while       
                --Otherwise, exit the market
                elsif input = length(commodities)+1 then
                    exit
                end if
            end while
        -- Go to tavern
        elsif input = 2 then
            while 1 do
                print_header()
                input = in_tavern()
                    -- Drink and gossip
                    if input = 1 then
                        -- Do you have money?
                        if player[GOLD] >= 1 then
                            player[GOLD] -= 1
                            print_header()
                            input = rand(length(commodities))
                            -- Gossip about buying
                            if ports[input][PRICES][input][BUY] = 0 then
                                printf(1, "*Hic!* I hear that %s can be bought for %d gold at the port of %s.\n\n", {commodities[input], ports[input][PRICES][input][SELL], ports[input][NAME]})
                                puts(1, "Press any key")
                            -- Gossip about selling
                            else
                                printf(1, "*Hic!* I hear they sell %s for %d gold at the port of %s.\n\n", {commodities[input], ports[input][PRICES][input][BUY], ports[input][NAME]})
                                puts(1, "Press key")
                            end if
                        -- Cannot afford a drink
                        else
                            print_header()
                            puts(1, "You penniless lout! Come back when ye have money to spend!\n\n")
                            puts(1, "Press any key")
                        end if
                        key = wait_key()
                        key = -1
                    -- Play dice
                    elsif input = 2 then
                        while 1 do
                            print_header()
                            puts(1, "The rules are simple, mate. We each roll a six-sided die and whoever scores\nhighest wins the round.\n\n")
                            input = prompt_number("Place your bet (1 - 100): ", {1, 100})
                            -- Dice are rolled
                            junk = {rand(6), rand(6)}
                            -- You win
                            if junk[1] > junk[2] then
                                player[GOLD] += input
                                print_header()
                                printf(1, "CURSES!!! Your %d beats my %d. Looks like you win this round!\n\n", {junk[1], junk[2]})  
                                puts(1, "Press ESC to stop or any other to continue")
                                key = wait_key()
                                    if key = ESC then
                                        exit
                                    end if
                                -- You lose
                            elsif junk[1] < junk[2] then
                                player[GOLD] -= input
                                print_header()
                                printf(1, "HA! My %d beats your %d. Gimmee that beautiful gold, mate!!\n\n", {junk[2], junk[1]})    
                                puts(1, "Press ESC to stop or any other to continue")
                                key = wait_key()
                                    if key = ESC then
                                        key = -1
                                        exit
                                    end if
                            -- A tie
                            else
                                print_header()
                                puts(1, "It's a stinkin tie! How abouts another round?\n\n")
                                puts(1, "Press ESC to stop or any other to continue")
                                key = wait_key()
                                    if key = ESC then
                                        key = -1
                                        exit
                                    end if
                            end if
                        end while
                    -- Play black jack
                    elsif input = 3 then
                        -- Begin black jack game
                        while 1 do
                            print_header()
                            puts(1, "The game is Black Jack, mate. Face cards are worth 10, Aces are worth 11, all\nothers are worth their number.\n")
                            puts(1, "Point o' the game is to get as close to 21 points as possible without goin'\nover. Let's play!\n\n")
                            input = prompt_number("Place your bet: > ", {1, player[GOLD]})
                            shuffle_deck()
                            dealer_hand = {cards[1], cards[2]}
                            player_hand = {cards[3], cards[4]}
                            current_card = 4
                                -- Player phase
                                while 1 do
                                    print_header()
                                    -- Show player's and dealer's hand
                                    display_cards()
                                    -- Player hits or stands?
                                    puts(1, "\n\n(1) Take another card")
                                    puts(1, "\n(2) Keep what you have")
                                    screen = prompt_number("\n\nWhat'll it be? > ", {1,2})
                                    -- Player draws another card
                                    if screen = 1 then
                                        current_card += 1
                                        player_hand = append(player_hand, cards[current_card])
                                        -- Has player gone bust?
                                        t = 0
                                        -- Count cards
                                        for i = 1 to length(player_hand) do
                                            t += player_hand[i][3]  
                                        end for
                                            -- Bust!
                                            if t > 21 then
                                                print_header()
                                                display_cards()
                                                puts(1, "\n\nSorry mate but you've gone bust! I win this round!\n\n")
                                                player[GOLD] -= input
                                                puts(1, "Press any key")
                                                key = wait_key()
                                                key = -1
                                                -- Set a flag to skip the Dealer Phase
                                                t = 999
                                                exit
                                            end if
                                    -- Player stands
                                    elsif screen = 2 then                                       
                                        exit
                                    end if
                                end while
                            
                                -- Dealer phase
                                while 1 do
                                    -- Skip dealer phase?
                                    if t = 999 then
                                        t = 0
                                        exit
                                    end if
                                    print_header()
                                    -- Show player's and dealer's hand
                                    display_cards()
                                    -- Add up dealer's and player's hands
                                    t = 0
                                    for i = 1 to length(dealer_hand) do
                                        t += dealer_hand[i][3]  
                                    end for
                                    -- Add up player's hand
                                    key = 0
                                    for i = 1 to length(player_hand) do
                                        key += player_hand[i][3]    
                                    end for

                                    -- If dealer is losing 
                                    if t < key then
                                        current_card += 1
                                        dealer_hand = append(dealer_hand, cards[current_card])
                                    -- If dealer has a higher hand 
                                    elsif t > key and t <= 21 then
                                        print_header()
                                        display_cards()
                                        puts(1, "\n\nRead 'em and weep, matey! I win!")
                                        player[GOLD] -= input
                                        puts(1, "\n\nPress any key")
                                        key = wait_key()
                                        key = -1
                                        exit
                                    -- Dealer and player are tied
                                    elsif t = key then
                                        print_header()
                                        display_cards()
                                        puts(1, "\n\nAin't no way around it...it's a tie! Neither of us wins nor loses.")
                                        puts(1, "\n\nPress any key")
                                        key = wait_key()
                                        key = -1
                                        exit
                                    -- Dealer has busted!
                                    else
                                        if t > 21 then
                                            print_header()
                                            display_cards()
                                            puts(1, "\n\nDamn my luck! Looks like you win this round...!\n\n")
                                            player[GOLD] += input * 2
                                            puts(1, "Press any key")
                                            key = wait_key()
                                            key = -1
                                            exit
                                        end if  
                                    end if
                                end while
                            -- Play again?
                            print_header()
                            puts(1, "Press ESC to stop or any other key to continue")
                            key = wait_key()
                                if key = ESC then
                                    exit
                                end if
                        end while
                    -- Hire a crew						
                    elsif input = 4 then
                        print_header()
                        -- No room onboard for more sailors
                        if player[CREW][1] = player[CREW][2] then
                            puts(1, "You already have a full crew!\n\nPress any key")
                            key = wait_key()
                            key = -1
                        else
                            -- How many able seamen are available?
                            input = rand(player[CREW][2] - player[CREW][1])
                            if player[GOLD] >= input * 5 then   
                                printf(1, "There are %d unemployed sailors loitering in the tavern.\nThey will sign up for 5 gold each.\n\n", {input})
                                input = prompt_number("How many will you hire? ",{0, input})
                                player[GOLD] -= input * 5
                                player[CREW][1] += input
                            else
                                puts(1, "You don't have enough gold to hire anyone!\n\nPress any key to continue")
                                key = wait_key()
                            end if
                        end if
                    -- Leave tavern
                    elsif input = 5 then
                        exit
                    end if
            end while
        -- Go to ship yards
        elsif input = 3 then
            while 1 do
            print_header()
            input = in_shipyard()
                -- Rename Ship
                if input = 1 then
                    print_header()
                    player[NAME] = prompt_string("What shall your vessel be known as? (11 letter limit) > ")
                    -- Reduce name if too long
                    if length(player[NAME]) > 11 then
                        player[NAME] = player[NAME][1..11]
                    end if
                -- Make repairs
                elsif input = 2 then
                    -- No repairs needed
                    if player[HP][1] = player[HP][2] then
                        print_header()
                        puts(1, "Your ship is in fine shape, matey!\n\n")
                        puts(1, "Press any key")
                        key = wait_key()
                        key = -1
                    -- Repairs are needed	
                    else
                        print_header()
                        printf(1, "The %s has seen some rough seas, Mate, but we'll put her right!\n", {player[NAME]})
                        printf(1, "It'll cost ye %d gold pieces to fix her up completely.\n\n", {(player[HP][2] - player[HP][1]) * 40})
                        input = prompt_number("How much are you willing to spend? > ", {0, (player[HP][2] - player[HP][1]) * 40})
                        player[HP][1] += floor(input / 40)
                        player[GOLD] -= input 
                    end if
                -- Overhaul crew quarters
                elsif input = 3 then
                    print_header()
                    printf(1, "Right now you have bunks for %d crewmen.\nIt'll cost ye 5 gold per bunk to overhaul the crew quarters.\n\n", {player[CREW][2]})
                    -- For every 20 max cargo there must be 1 crewman
                    -- Max crew is 50 therefore max cargo is 1000
                    input = prompt_number("How many bunks do you want there to be? (10 to 50) > ", {10, 50})
                        -- Not enough gold!
                        if input * 5 > player[GOLD] then
                            print_header()
                            puts(1, "Sorry, Mate, but you don't have enough gold!\n\n")
                            puts(1, "Press any key")
                            key = wait_key()
                            key = -1
                        -- Make the changes
                        else
                            player[GOLD] -= input * 5
                            player[CREW][2] = input
                        end if
                -- Enlarge cargo hold
                elsif input = 4 then
                    print_header()
                    printf(1, "Ye have space for %d cargo in the %s.\nIt'll cost ye 10 gold to add 1 cargo space.\n\n", {player[CARGO][2], player[NAME]})
                    input = prompt_number("How many will ye be wanting to add? > ", {0, 1000 - player[CARGO][2]})
                        -- Not enough money!
                        if player[GOLD] < input * 10 then
                            print_header()
                            puts(1, "Bah! You don't even have the coins to pay! Stop wasting my time!\n\n")
                            puts(1, "Press any key")
                            key = wait_key()
                            key = -1
                        -- Add new cargo spaces
                        else
                            player[GOLD] -= input * 10
                            player[CARGO][2] += input
                        end if
                -- Leave the ship yards
                elsif input = 5 then
                    exit
                end if
            end while
        -- Book a room at the inn
        elsif input = 4 then
            while 1 do
                print_header()
                input = in_inn()
                    -- Stay the night	
                    if input = 1 then
                        print_header()
                        puts(1, "Welcome to my inn, good sir!\nI hope that you will enjoy your stay.\n\nPress any key")
                        key = wait_key()
                        key = -1
                        change_date(1)
                        -- Game is saved
                        input = open(current_dir() & "\\" & player[NAME] & ".SAV", "w")
                            -- Error saving game
                            if input = -1 then
                                print_header()
                                puts(1, "I'm sorry but your game couldn't be saved...\n\n")
                                puts(1, "Press any key")
                                key = wait_key()
                                key = -1
                            -- Game is saved								
                            else
                                print(input, player)
                                print(input, ports)
                                print(input, location)
                                print(input, Date)
                                print(input, days_left)
                                close(input)
                                print_header()
                                printf(1, "Your game has been saved as %s\n\n", {player[NAME] & ".SAV"})
                                -- Leave game?
                                puts(1, "Would you like to quit?\n\n")
                                puts(1, "(1) Yes\n(2) No\n\n")
                                input = prompt_number("> ", {1,2})
                                    -- Exit game
                                    if input = 1 then
                                        clear_screen()
                                        abort(0)
                                    end if
                            end if
                    -- Quit game without saving							
                    elsif input = 2 then
                        print_header()
                        puts(1, "Quit game without saving?\n\n")
                        puts(1, "(1) Yes\n(2) No\n\n")
                        input = prompt_number("> ", {1,2})
                            -- Exit game
                            if input = 1 then
                                clear_screen()
                                abort(0)
                            end if
                    -- Leave the inn	
                    elsif input = 3 then    
                        exit
                    end if
            end while
        -- Set sail!
        elsif input = 5 then
            -- Check ship conditions
            -- Not enough crew!
            if floor(player[CARGO][2] / 20) > player[CREW][1] then
                print_header()
                printf(1, "We aren't going to get anywhere with only %d crewmen!\nWe need at least %d to work the ship!\n\n", {player[CREW][1], floor(player[CARGO][2] / 20)})
                puts(1, "Press any key")
                key = wait_key()
                key = -1
            else
                print_header()
                input = set_sail()
                if input != location then
                    destination = input
                        -- Sail between ports
                        -- 1 in 5 chance of an event happening
                        screen = rand(5)
                        -- Count down days at sea
                        for i = distances[location][destination] to 1 by - 1 do
                            print_header()
                            change_date(1)
                            printf(1, "We will arrive in %s in %d days.", {ports[destination][NAME], i})
                            t = time()
                            -- Brief pause
                            while t + 0.7 > time() do
                            end while
                                -- If an event happens
                                if screen = 1 then
                                    screen = rand(6)
                                        -- Fair winds speed voyage
                                        if screen = 1 then
                                            print_header()
                                            printf(1, "Fair winds and good weather speeds your voyage to %s!\n\n", {ports[destination][NAME]})
                                            puts(1, "Press any key")
                                            change_date(floor(distances[location][destination] / 2))
                                            key = wait_key()
                                            key = -1
                                            screen = 0
                                            exit
                                        -- Foul winds extend voyage
                                        elsif screen = 2 then
                                            print_header()
                                            printf(1, "Foul winds and stormy weather delays your voyage to %s!\n\n", {ports[destination][NAME]})
                                            puts(1, "Press any key")
                                            change_date(rand(5))
                                            key = wait_key()
                                            key = -1
                                            screen = 0
                                        -- Storm damages your ship
                                        elsif screen = 3 then
                                            print_header()
                                            printf(1, "A storm rises!\nWaves pound the %s mercilessly and she is damaged!\n\n", {player[NAME]})
                                            puts(1, "Press any key")
                                            player[HP][1] -= rand(5)
                                                if player[HP][1] <= 0 then
                                                    game_over()
                                                end if
                                            key = wait_key()
                                            key = -1
                                            screen = 0
                                        -- Rats damage cargo
                                        elsif screen = 4 and player[CARGO][1] > 5 then
                                            print_header()
                                            -- Randomly select cargo to lose
                                                while 1 do
                                                    screen = rand(length(commodities))
                                                        if player[6][screen] > 0 then
                                                            exit
                                                        end if
                                                end while
                                            printf(1, "Sakes alive! Rats have ruined some of our cargo of %s, Captain!\n\n", {commodities[screen]}) 
                                            puts(1, "Press any key")
                                            -- Up to a 1/4 of that cargo lost
                                            player[6][screen] -= rand(floor(player[6][screen]/4))
                                            key = wait_key()
                                            key = -1
                                            screen = 0
                                        -- Attacked by pirates
                                        elsif screen = 5 then
                                            print_header()
                                            puts(1, "There's a ship coming up fast astern, Captain, and she's hoisting her colors...\nIt's filthy pirates!\n")
                                            puts(1, "You are quickly outrun and grappled by the faster ship. Pirates swarm aboard andyou find yourself facing their menacing captain.\n\n")
                                            puts(1, "Press any key")
                                            key = wait_key()
                                            key = -1
                                            input = combat()
                                                -- You win
                                                if input = 1 then
                                                    -- Crew casualties up to 25%
                                                    input = rand(floor(player[CREW][1] / 4))
                                                    print_header()
                                                    puts(1, "Victory!\n\nThe pirates lose heart and flee back to their ship as their captain falls to\nyour swordplay!\n\n")
                                                    printf(1, "It has been a hard battle.\n%d crewmen were killed and the %s has been damaged.\n\n", {input, player[NAME]})
                                                    puts(1, "Press any key")
                                                        key = wait_key()
                                                        key = -1
                                                        player[CREW][1] -= input
                                                        -- Damage to the ship
                                                        player[HP][1] -= rand(5)
                                                            -- Will the ship sink?
                                                            if player[HP][1] <= 0 then
                                                                game_over()
                                                            end if
                                                    print_header()
                                                    input = rand(2000)
                                                    printf(1, "Yet, there is good news as well!\n\nThere was a bounty of %d gold on the pirate captain's head!\n\n", {input})
                                                    puts(1, "Press any key")
                                                    player[GOLD] += input
                                                    key = wait_key()
                                                    key = -1
                                                -- Pirates win
                                                elsif input = 2 then
                                                    print_header()
                                                    puts(1, "Defeat!\n\nThe pirate captain is your superior in swordplay and sheer ferocity! Wounded\n")
                                                    puts(1, "and exhausted, you and the crew have no choice but to surrender...\n\n")
                                                    printf(1, "The jeering pirates pillage the %s finding and taking the following\ntreasures:\n\n", {player[NAME]})
                                                        -- Plunder cargo
                                                        for j = 1 to length(commodities) do
                                                            if player[6][j] > 0 then
                                                                input = rand(player[6][j])
                                                                printf(1, "%d %s\n", {input, commodities[j]})
                                                                player[6][j] -= input
                                                            end if
                                                        end for
                                                        -- Steal gold
                                                        input = rand(player[GOLD])
                                                        printf(1, "%d gold pieces\n\n", {input})
                                                        player[GOLD] -= input
                                                        puts(1, "Press any key")
                                                        key = wait_key()
                                                        key = -1
                                                        print_header()
                                                        -- Up to 50% crew killed
                                                        input = rand(floor(player[CREW][1]/2))
                                                        printf(1, "It has been a hard battle.\n%d crewmen were killed and the %s has been damaged.\n\n", {input, player[NAME]})
                                                        puts(1, "Press any key")
                                                        key = wait_key()
                                                        key = -1
                                                        player[CREW][1] -= input
                                                        -- Damage to the ship
                                                        player[HP][1] -= rand(5)
                                                            -- Will the ship sink?
                                                            if player[HP][1] <= 0 then
                                                                game_over()
                                                            end if
                                                end if
                                        -- Mutiny!
                                        elsif screen = 6 then
                                            print_header()
                                            printf(1, "The crew seems sullen and goes about its work with much muttering. Belief is\nspreading that the %s is under a curse!\n\n", {player[NAME]})
                                            puts(1, "A delegation of men sheepishly comes to your cabin that night. 'Not meaning any\noffense, Cap'n, but we don't want to serve ")
                                            puts(1, "on no bad luck ship. We is getting\noff at the next port.'\n\n")
                                            input = rand(floor(player[CREW][1] / 4))
                                            printf(1, "In all, %d crewmen will resign when you reach %s, and will have to be\nreplaced.", {input, ports[destination][NAME]})
                                            player[CREW][1] -= input
                                            key = wait_key()
                                            key = -1
                                            
                                        end if
                                end if
                        end for 
                    location = destination
                end if
            end if
        end if
end while